/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package PluginsCreation;

import InputOutput.ReverseWrapper;
import generator.IGenerator;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Scanner;
import structures.IAttribute;
import structures.IReference;
import structures.ITable;

/**
 *
 * @author mates
 */
public class MySqlGenerator implements IGenerator, Serializable {

    private ArrayList<ITable> tables;
    private ArrayList<IReference> references;

    public String generate() {
        String NL = System.getProperty("line.separator");
        StringBuilder s = new StringBuilder();
        for (int i = 0; i < tables.size(); i++) {
            s.append("CREATE TABLE ").append(tables.get(i).getName()).append(" (").append(NL);
            for (int j = 0; j < tables.get(i).getAttributeList().size(); j++) {
                IAttribute attr = tables.get(i).getAttributeList().get(j);
                s.append("\t\t").append(attr.getName());
                s.append("\t\t").append(attr.getDataType().getName());
                if (!attr.getDataType().getArgs().isEmpty()) {
                    s.append("( ");
                    for (int k = 0; k < attr.getDataType().getArgs().size(); k++) {
                        s.append(attr.getArguments().get(i).intValue());
                        if (k != attr.getDataType().getArgs().size() - 1) {
                            s.append(", ");
                        }
                    }
                    s.append(" )");
                }
                if (attr.isNotNull()) {
                    s.append("\tNOT NULL");
                }
                if (attr.isAutoIncrement()) {
                    s.append("\tAUTO_INCREMENT");
                }
                if (j != tables.get(i).getAttributeList().size() - 1) {
                    s.append(",").append(NL);
                }
            }
            s.append(NL).append(");");
            s.append(NL).append(NL);
        }
        for (int i = 0; i < tables.size(); i++) {
            if (tables.get(i).getPrimaryKey().size() == 0) {
                continue;
            }
            s.append("ALTER TABLE ").append(tables.get(i).getName()).append(NL);
            s.append("\tADD CONSTRAINT ").append(tables.get(i).getName()).append("_PK ");
            s.append("PRIMARY KEY ( ");
            for (int j = 0; j < tables.get(i).getPrimaryKey().size(); j++) {
                s.append(tables.get(i).getPrimaryKey().get(j).getName());
                if (tables.get(i).getPrimaryKey().size() - 1 != j) {
                    s.append(", ");
                }
            }
            s.append(" );").append(NL).append(NL).append(NL);
        }

        for (int i = 0; i < references.size(); i++) {
            ITable tpk = references.get(i).getTableWithFK();
            ITable rt = references.get(i).getReferencedTable();
            s.append("ALTER TABLE ").append(references.get(i).getTableWithFK().getName()).append(NL);
            s.append("\tADD CONSTRAINT ").append(tpk.getName()).append("_").append(rt.getName()).append("_FK ");
            s.append("FOREIGN KEY ( ");
            for (int j = 0; j < references.get(i).getAttributeWithFK().size(); j++) {
                IAttribute attr = references.get(i).getAttributeWithFK().get(j);
                s.append(attr.getName());
                if (references.get(i).getAttributeWithFK().size() - 1 != j) {
                    s.append(", ");
                }
            }
            s.append(" ) REFERENCES ");
            s.append(references.get(i).getReferencedTable().getName());
            s.append(" ( ");
            for (int j = 0; j < references.get(i).getReferencedTable().getPrimaryKey().size(); j++) {
                IAttribute attr = references.get(i).getReferencedTable().getPrimaryKey().get(j);
                s.append(attr.getName());
                if (references.get(i).getReferencedTable().getPrimaryKey().size() - 1 != j) {
                    s.append(", ");
                }
            }
            s.append(" );").append(NL).append(NL).append(NL);
        }

        return s.toString();
    }

    public ReverseWrapper reverseEngineer(Scanner scanner) throws UnsupportedOperationException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public ArrayList<IReference> getReferences() {
        return references;
    }

    public ArrayList<ITable> getTables() {
        return tables;
    }

    public void setReferences(ArrayList<IReference> references) {
        this.references = references;
    }

    public void setTables(ArrayList<ITable> tables) {
        this.tables = tables;
    }

}
