/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package generator;

import java.util.ArrayList;
import structures.IAttribute;
import structures.IReference;
import structures.ITable;

/**
 *
 * @author mates
 */
public class XmlGenerator {

    private ArrayList<ITable> tables;
    private ArrayList<IReference> references;

    public XmlGenerator(ArrayList<ITable> tables, ArrayList<IReference> refs) {
        this.tables = tables;
        this.references = refs;
    }

    public String generate() {
        String NL = System.getProperty("line.separator");
        StringBuilder s = new StringBuilder();
        s.append("<database>").append(NL);
        for (int i = 0; i < tables.size(); i++) {
            s.append("\t<table name='").append(tables.get(i).getName()).append("'>").append(NL);
            for (IAttribute attr : tables.get(i).getAttributeList()) {
                s.append("\t\t<attribute ");
                s.append("dataType='").append(attr.getDataType()).append("' ");
                for (int j = 0; j < attr.getDataType().getArgs().size(); j++) {
                    s.append(attr.getDataType().getArgs().get(j)).append("='");
                    s.append(attr.getArguments().get(j)).append("' ");
                }
                s.append("primaryKey='").append(attr.isPrimaryKey()?"yes":"no").append("' ");
                s.append("unique='").append(attr.isUnique()?"yes":"no").append("' ");
                s.append("notNull='").append(attr.isNotNull()?"yes":"no").append("' ");
                s.append("autoIncrement='").append(attr.isAutoIncrement()?"yes":"no").append("'");
                s.append(">");
                s.append(attr.getName());
                s.append("</attribute>").append(NL);
            }
            s.append("\t</table>").append(NL);
        }
        for (int i = 0; i < references.size(); i++) {
            s.append("\t<relation table='").append(references.get(i).getTableWithFK().getName()).append("' ");
            s.append("referencedTable='").append(references.get(i).getReferencedTable().getName()).append("'>").append(NL);
            for (int j = 0; j < references.get(i).getAttributeWithFK().size(); j++) {
                s.append("\t\t<foreignKey>").append(references.get(i).getAttributeWithFK().get(j).getName());
                s.append("</foreignKey>").append(NL);
            }
            s.append("\t</relation>").append(NL);
        }
        s.append("</database>");
        return s.toString();
    }

}
