/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MainFrame.java
 *
 * Created on 22.4.2011, 13:58:04
 */
package graphics;

import InputOutput.ReverseWrapper;
import InputOutput.SavingWrapper;
import com.sun.java.swing.plaf.windows.resources.windows_de;
import generator.DefaultGenerator;
import generator.IGenerator;
import generator.XmlGenerator;
import init.DefaultDataTypes;
import init.IDataTypes;
import java.awt.Desktop;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Observable;
import java.util.Observer;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.DefaultListModel;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JSpinner;
import javax.swing.UIManager;
import javax.swing.filechooser.FileFilter;
import manual.ThreadStarter;
import structures.IAttribute;
import structures.IReference;
import structures.ISqlDataType;
import structures.ITable;

/**
 *
 * @author mates
 */
public class MainFrame extends javax.swing.JFrame implements Observer {

    private PanelModel panelModel;
    private DefaultDataTypes defaultTypes;
    private ArrayList<IDataTypes> dbSpecificTypes = new ArrayList<IDataTypes>();
    private IGenerator generator;

    /** Creates new form MainFrame */
    public MainFrame() {
        this.defaultTypes = new DefaultDataTypes();

        try {
            UIManager.setLookAndFeel(
                    UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
        }

        initComponents();
        JFormattedTextField tf = ((JSpinner.DefaultEditor) spinnerArg1.getEditor()).getTextField();
        tf.setEditable(false);
        tf = ((JSpinner.DefaultEditor) spinnerArg2.getEditor()).getTextField();
        tf.setEditable(false);

        MouseListener spinListener1 = new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent e) {
                spinnerArg1MouseClicked(e);
            }
        };
        KeyListener spinKeyListener1 = new KeyAdapter() {

            @Override
            public void keyReleased(KeyEvent e) {
                spinnerArg1MouseClicked(null);
            }
        };
        MouseListener spinListener2 = new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent e) {
                spinnerArg2MouseClicked(e);
            }
        };
        KeyListener spinKeyListener2 = new KeyAdapter() {

            @Override
            public void keyReleased(KeyEvent e) {
                spinnerArg2MouseClicked(null);
            }
        };
        spinnerArg1.getComponent(0).addMouseListener(spinListener1);
        spinnerArg1.getComponent(1).addMouseListener(spinListener1);
        ((JSpinner.DefaultEditor) spinnerArg1.getEditor()).getTextField().addKeyListener(spinKeyListener1);
        ((JSpinner.DefaultEditor) spinnerArg1.getEditor()).getTextField().addKeyListener(spinKeyListener1);

        spinnerArg2.getComponent(0).addMouseListener(spinListener2);
        spinnerArg2.getComponent(1).addMouseListener(spinListener2);
        spinnerArg2.addKeyListener(spinKeyListener2);
        spinnerArg2.addKeyListener(spinKeyListener2);

        panelModel = new PanelModel(this, defaultTypes, dbSpecificTypes);
        scrollPane.setViewportView(panelModel);
        initDataTypes();
        this.setExtendedState(Frame.MAXIMIZED_BOTH);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu4 = new javax.swing.JMenu();
        jMenu5 = new javax.swing.JMenu();
        toolBarTop = new javax.swing.JToolBar();
        btnAddAttribute = new javax.swing.JButton();
        btnRemoveAttribute = new javax.swing.JButton();
        jSeparator5 = new javax.swing.JToolBar.Separator();
        btnMoveUp = new javax.swing.JButton();
        btnMoveDown = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        togglePrimaryKey = new javax.swing.JToggleButton();
        toggleUnique = new javax.swing.JToggleButton();
        toggleNotNull = new javax.swing.JToggleButton();
        toggleAutoInc = new javax.swing.JToggleButton();
        jSeparator4 = new javax.swing.JToolBar.Separator();
        toggleForeignKey = new javax.swing.JToggleButton();
        btnRemoveForeignKey = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        toogleHideRelationPoints = new javax.swing.JToggleButton();
        jSeparator6 = new javax.swing.JToolBar.Separator();
        labelPlugin = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        panelNewTable = new javax.swing.JPanel();
        toggleNewTable = new javax.swing.JToggleButton();
        toggleNewTableId = new javax.swing.JToggleButton();
        toggleRemoveTable = new javax.swing.JToggleButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        listSqlDataTypes = new javax.swing.JList();
        labelSpecificTypes = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        listSpecificDataTypes = new javax.swing.JList();
        spinnerArg2 = new javax.swing.JSpinner();
        spinnerArg1 = new javax.swing.JSpinner();
        labelDataTypeArg1 = new javax.swing.JLabel();
        labelDataTypeArg2 = new javax.swing.JLabel();
        scrollPane = new javax.swing.JScrollPane();
        menuBar = new javax.swing.JMenuBar();
        menuFile = new javax.swing.JMenu();
        menuItemOpen = new javax.swing.JMenuItem();
        menuItemSave = new javax.swing.JMenuItem();
        menuImport = new javax.swing.JMenu();
        menuItemImportDdl = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        exportToPngItem = new javax.swing.JMenuItem();
        menuItemXMLExport = new javax.swing.JMenuItem();
        menuItemExportDdl = new javax.swing.JMenuItem();
        menuChooseMode = new javax.swing.JMenu();
        menuItemChooseSystem = new javax.swing.JMenuItem();
        menuHelp = new javax.swing.JMenu();
        menuItemHelp = new javax.swing.JMenuItem();

        jMenu4.setText("File");
        jMenuBar1.add(jMenu4);

        jMenu5.setText("Edit");
        jMenuBar1.add(jMenu5);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                formKeyPressed(evt);
            }
        });

        toolBarTop.setFloatable(false);
        toolBarTop.setRollover(true);

        btnAddAttribute.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/add_attr.png"))); // NOI18N
        btnAddAttribute.setToolTipText("add attribute to current table");
        btnAddAttribute.setEnabled(false);
        btnAddAttribute.setFocusable(false);
        btnAddAttribute.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnAddAttribute.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnAddAttribute.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddAttributeActionPerformed(evt);
            }
        });
        toolBarTop.add(btnAddAttribute);

        btnRemoveAttribute.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/delete_attr.png"))); // NOI18N
        btnRemoveAttribute.setToolTipText("remove selected attribute");
        btnRemoveAttribute.setEnabled(false);
        btnRemoveAttribute.setFocusable(false);
        btnRemoveAttribute.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnRemoveAttribute.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnRemoveAttribute.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemoveAttributeActionPerformed(evt);
            }
        });
        toolBarTop.add(btnRemoveAttribute);
        toolBarTop.add(jSeparator5);

        btnMoveUp.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/up.png"))); // NOI18N
        btnMoveUp.setToolTipText("move up");
        btnMoveUp.setEnabled(false);
        btnMoveUp.setFocusable(false);
        btnMoveUp.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnMoveUp.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnMoveUp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnMoveUpActionPerformed(evt);
            }
        });
        toolBarTop.add(btnMoveUp);

        btnMoveDown.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/down.png"))); // NOI18N
        btnMoveDown.setToolTipText("move down");
        btnMoveDown.setEnabled(false);
        btnMoveDown.setFocusable(false);
        btnMoveDown.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnMoveDown.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnMoveDown.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnMoveDownActionPerformed(evt);
            }
        });
        toolBarTop.add(btnMoveDown);
        toolBarTop.add(jSeparator3);

        togglePrimaryKey.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/key.png"))); // NOI18N
        togglePrimaryKey.setToolTipText("set/unset as primary key");
        togglePrimaryKey.setEnabled(false);
        togglePrimaryKey.setFocusable(false);
        togglePrimaryKey.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        togglePrimaryKey.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        togglePrimaryKey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                togglePrimaryKeyActionPerformed(evt);
            }
        });
        toolBarTop.add(togglePrimaryKey);

        toggleUnique.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/unique.png"))); // NOI18N
        toggleUnique.setToolTipText("set/unset unique");
        toggleUnique.setEnabled(false);
        toggleUnique.setFocusable(false);
        toggleUnique.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        toggleUnique.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        toggleUnique.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toggleUniqueActionPerformed(evt);
            }
        });
        toolBarTop.add(toggleUnique);

        toggleNotNull.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/not_null.png"))); // NOI18N
        toggleNotNull.setToolTipText("set/unset not null");
        toggleNotNull.setEnabled(false);
        toggleNotNull.setFocusable(false);
        toggleNotNull.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        toggleNotNull.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        toggleNotNull.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toggleNotNullActionPerformed(evt);
            }
        });
        toolBarTop.add(toggleNotNull);

        toggleAutoInc.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/auto_increment.png"))); // NOI18N
        toggleAutoInc.setToolTipText("set/unset auto-increment");
        toggleAutoInc.setEnabled(false);
        toggleAutoInc.setFocusable(false);
        toggleAutoInc.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        toggleAutoInc.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        toggleAutoInc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toggleAutoIncActionPerformed(evt);
            }
        });
        toolBarTop.add(toggleAutoInc);
        toolBarTop.add(jSeparator4);

        toggleForeignKey.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/foreign_key.png"))); // NOI18N
        toggleForeignKey.setToolTipText("create foreign key");
        toggleForeignKey.setEnabled(false);
        toggleForeignKey.setFocusable(false);
        toggleForeignKey.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        toggleForeignKey.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        toggleForeignKey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toggleForeignKeyActionPerformed(evt);
            }
        });
        toolBarTop.add(toggleForeignKey);

        btnRemoveForeignKey.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/foreign_key_delete.png"))); // NOI18N
        btnRemoveForeignKey.setToolTipText("remove foreign key");
        btnRemoveForeignKey.setEnabled(false);
        btnRemoveForeignKey.setFocusable(false);
        btnRemoveForeignKey.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnRemoveForeignKey.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnRemoveForeignKey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemoveForeignKeyActionPerformed(evt);
            }
        });
        toolBarTop.add(btnRemoveForeignKey);
        toolBarTop.add(jSeparator1);

        toogleHideRelationPoints.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/manipulationPoints.png"))); // NOI18N
        toogleHideRelationPoints.setToolTipText("hide/show manipulation points");
        toogleHideRelationPoints.setFocusable(false);
        toogleHideRelationPoints.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        toogleHideRelationPoints.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        toogleHideRelationPoints.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toogleHideRelationPointsActionPerformed(evt);
            }
        });
        toolBarTop.add(toogleHideRelationPoints);
        toolBarTop.add(jSeparator6);

        labelPlugin.setText("Loaded: Generic SQL");
        toolBarTop.add(labelPlugin);

        getContentPane().add(toolBarTop, java.awt.BorderLayout.PAGE_START);

        jPanel2.setPreferredSize(new java.awt.Dimension(230, 602));

        toggleNewTable.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/table.png"))); // NOI18N
        toggleNewTable.setFocusable(false);
        toggleNewTable.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        toggleNewTable.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        toggleNewTable.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toggleNewTableActionPerformed(evt);
            }
        });
        panelNewTable.add(toggleNewTable);

        toggleNewTableId.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/table_with_id.png"))); // NOI18N
        toggleNewTableId.setToolTipText("new table with id");
        toggleNewTableId.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toggleNewTableIdActionPerformed(evt);
            }
        });
        panelNewTable.add(toggleNewTableId);

        toggleRemoveTable.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/remove_table.png"))); // NOI18N
        toggleRemoveTable.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toggleRemoveTableActionPerformed(evt);
            }
        });
        panelNewTable.add(toggleRemoveTable);

        jLabel1.setText("SQL data types:");

        listSqlDataTypes.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        listSqlDataTypes.setEnabled(false);
        listSqlDataTypes.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                listSqlDataTypesMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(listSqlDataTypes);

        labelSpecificTypes.setText("DB specific types:");

        listSpecificDataTypes.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_INTERVAL_SELECTION);
        listSpecificDataTypes.setEnabled(false);
        listSpecificDataTypes.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                listSpecificDataTypesMouseClicked(evt);
            }
        });
        jScrollPane2.setViewportView(listSpecificDataTypes);

        spinnerArg2.setEnabled(false);

        spinnerArg1.setEnabled(false);

        labelDataTypeArg1.setText(" ");

        labelDataTypeArg2.setText(" ");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator2, javax.swing.GroupLayout.DEFAULT_SIZE, 206, Short.MAX_VALUE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 206, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 206, Short.MAX_VALUE)
                    .addComponent(panelNewTable, javax.swing.GroupLayout.DEFAULT_SIZE, 206, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 206, Short.MAX_VALUE)
                    .addComponent(labelSpecificTypes, javax.swing.GroupLayout.DEFAULT_SIZE, 206, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(labelDataTypeArg2, javax.swing.GroupLayout.DEFAULT_SIZE, 134, Short.MAX_VALUE)
                            .addComponent(labelDataTypeArg1, javax.swing.GroupLayout.DEFAULT_SIZE, 134, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(spinnerArg2)
                            .addComponent(spinnerArg1, javax.swing.GroupLayout.DEFAULT_SIZE, 60, Short.MAX_VALUE))))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(panelNewTable, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(8, 8, 8)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 83, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(spinnerArg1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labelDataTypeArg1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(spinnerArg2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labelDataTypeArg2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(labelSpecificTypes)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE)
                .addContainerGap())
        );

        getContentPane().add(jPanel2, java.awt.BorderLayout.LINE_START);
        getContentPane().add(scrollPane, java.awt.BorderLayout.CENTER);

        menuFile.setText("File");

        menuItemOpen.setText("Open");
        menuItemOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemOpenActionPerformed(evt);
            }
        });
        menuFile.add(menuItemOpen);

        menuItemSave.setText("Save");
        menuItemSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemSaveActionPerformed(evt);
            }
        });
        menuFile.add(menuItemSave);

        menuImport.setText("Import");

        menuItemImportDdl.setText("DDL script");
        menuItemImportDdl.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemImportDdlActionPerformed(evt);
            }
        });
        menuImport.add(menuItemImportDdl);

        menuFile.add(menuImport);

        jMenu3.setText("Export");

        exportToPngItem.setText("PNG image");
        exportToPngItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportToPngItemActionPerformed(evt);
            }
        });
        jMenu3.add(exportToPngItem);

        menuItemXMLExport.setText("XML file");
        menuItemXMLExport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemXMLExportActionPerformed(evt);
            }
        });
        jMenu3.add(menuItemXMLExport);

        menuItemExportDdl.setText("DDL script");
        menuItemExportDdl.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemExportDdlActionPerformed(evt);
            }
        });
        jMenu3.add(menuItemExportDdl);

        menuFile.add(jMenu3);

        menuBar.add(menuFile);

        menuChooseMode.setText("Preferences");

        menuItemChooseSystem.setText("Choose DB system");
        menuItemChooseSystem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemChooseSystemActionPerformed(evt);
            }
        });
        menuChooseMode.add(menuItemChooseSystem);

        menuBar.add(menuChooseMode);

        menuHelp.setText("Help");

        menuItemHelp.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F1, 0));
        menuItemHelp.setText("Manual");
        menuItemHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemHelpActionPerformed(evt);
            }
        });
        menuHelp.add(menuItemHelp);

        menuBar.add(menuHelp);

        setJMenuBar(menuBar);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void toggleNewTableActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toggleNewTableActionPerformed
        if (toggleNewTable.isSelected()) {
            panelModel.setMode(1);
            setButtonsByAttribute(null);
            panelModel.setActiveTableComponent(null);
            setButtonsByTable();
            setButtonsByMode();
        } else {
            panelModel.setMode(0);
            setButtonsByMode();
        }
    }//GEN-LAST:event_toggleNewTableActionPerformed

    private void btnAddAttributeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddAttributeActionPerformed
        panelModel.addNewAttributeToActiveTable();
    }//GEN-LAST:event_btnAddAttributeActionPerformed

    private void togglePrimaryKeyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_togglePrimaryKeyActionPerformed
        panelModel.setCurrentAttributeAs(1, togglePrimaryKey.isSelected());
    }//GEN-LAST:event_togglePrimaryKeyActionPerformed

    private void toggleUniqueActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toggleUniqueActionPerformed
        panelModel.setCurrentAttributeAs(2, toggleUnique.isSelected());
    }//GEN-LAST:event_toggleUniqueActionPerformed

    private void toggleNotNullActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toggleNotNullActionPerformed
        panelModel.setCurrentAttributeAs(3, toggleNotNull.isSelected());
    }//GEN-LAST:event_toggleNotNullActionPerformed

    private void toggleAutoIncActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toggleAutoIncActionPerformed
        panelModel.setCurrentAttributeAs(4, toggleAutoInc.isSelected());
    }//GEN-LAST:event_toggleAutoIncActionPerformed

    private void listSqlDataTypesMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listSqlDataTypesMouseClicked
        if (listSqlDataTypes.getSelectedIndex() != -1) {
            listSpecificDataTypes.clearSelection();
        }
        panelModel.setCurrentAttributeType((ISqlDataType) listSqlDataTypes.getSelectedValue());
    }//GEN-LAST:event_listSqlDataTypesMouseClicked

    private void btnRemoveAttributeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemoveAttributeActionPerformed
        panelModel.deleteCurentAttribute();
    }//GEN-LAST:event_btnRemoveAttributeActionPerformed

    private void exportToPngItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportToPngItemActionPerformed
        JFileChooser fc = new JFileChooser();
        FileFilter ff = new FileFilter() {

            @Override
            public boolean accept(File f) {
                return f.isDirectory() || f.getName().toLowerCase().endsWith(".png");
            }

            @Override
            public String getDescription() {
                return ".png files";
            }
        };
        fc.setFileFilter(ff);
        File f = null;
        if (fc.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            f = fc.getSelectedFile();
        } else {
            return;
        }

        BufferedImage bi = new BufferedImage(
                panelModel.getWidth(),
                panelModel.getHeight(),
                BufferedImage.TYPE_INT_ARGB);
        Graphics g = bi.createGraphics();
        panelModel.paint(g);  //this == JComponent
        g.dispose();
        try {
            ImageIO.write(bi, "png", f);
        } catch (IOException e) {
            JOptionPane.showMessageDialog(this, "Export error", "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_exportToPngItemActionPerformed

    private void btnMoveUpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnMoveUpActionPerformed
        panelModel.moveCurrentAttributeUp();
    }//GEN-LAST:event_btnMoveUpActionPerformed

    private void btnMoveDownActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnMoveDownActionPerformed
        panelModel.moveCurrentAttributeDown();
    }//GEN-LAST:event_btnMoveDownActionPerformed

    private void toggleForeignKeyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toggleForeignKeyActionPerformed
        panelModel.setCurrentAttributeAsForeignKey(toggleForeignKey.isSelected());
    }//GEN-LAST:event_toggleForeignKeyActionPerformed

    private void menuItemExportDdlActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemExportDdlActionPerformed
        ArrayList<ITable> tableArray = new ArrayList<ITable>();
        ArrayList<IReference> refArray = new ArrayList<IReference>();
        for (int i = 0; i < panelModel.getComponentCount(); i++) {
            tableArray.add(((TableComponent) panelModel.getComponent(i)).getTable());
        }
        for (int i = 0; i < panelModel.getReferences().size(); i++) {
            refArray.add(panelModel.getReferences().get(i).getReference());
        }

        JFileChooser fc = new JFileChooser();
        FileFilter ff = new FileFilter() {

            @Override
            public boolean accept(File f) {
                return f.isDirectory() || f.getName().toLowerCase().endsWith(".sql");
            }

            @Override
            public String getDescription() {
                return ".sql files";
            }
        };
        fc.setFileFilter(ff);
        File f = null;
        if (fc.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            f = fc.getSelectedFile();
        } else {
            return;
        }

        if (generator == null) {
            generator = new DefaultGenerator();
        }
        generator.setTables(tableArray);
        generator.setReferences(refArray);

        String savingString;
        try {
            savingString = generator.generate();
        } catch (UnsupportedOperationException e) {
            JOptionPane.showMessageDialog(this, "Loaded plugin do not support this action.");
            return;
        }

        FileWriter outFile = null;
        try {
            outFile = new FileWriter(f);
            PrintWriter out = new PrintWriter(outFile);
            out.print(savingString);
        } catch (IOException ex) {
        } finally {
            try {
                outFile.close();
            } catch (IOException ex) {
            }
        }
    }//GEN-LAST:event_menuItemExportDdlActionPerformed

    private void toogleHideRelationPointsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toogleHideRelationPointsActionPerformed
        panelModel.setShowReferencePoints(!toogleHideRelationPoints.isSelected());
        panelModel.repaint();
    }//GEN-LAST:event_toogleHideRelationPointsActionPerformed

    private void menuItemXMLExportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemXMLExportActionPerformed
        ArrayList<ITable> tableArray = new ArrayList<ITable>();
        ArrayList<IReference> refArray = new ArrayList<IReference>();
        for (int i = 0; i < panelModel.getComponentCount(); i++) {
            tableArray.add(((TableComponent) panelModel.getComponent(i)).getTable());
        }
        for (int i = 0; i < panelModel.getReferences().size(); i++) {
            refArray.add(panelModel.getReferences().get(i).getReference());
        }

        JFileChooser fc = new JFileChooser();
        FileFilter ff = new FileFilter() {

            @Override
            public boolean accept(File f) {
                return f.isDirectory() || f.getName().toLowerCase().endsWith(".xml");
            }

            @Override
            public String getDescription() {
                return ".xml files";
            }
        };
        fc.setFileFilter(ff);
        File f = null;
        if (fc.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            f = fc.getSelectedFile();
        } else {
            return;
        }

        XmlGenerator gen = new XmlGenerator(
                tableArray,
                refArray);
        FileWriter outFile = null;
        try {
            outFile = new FileWriter(f);
            PrintWriter out = new PrintWriter(outFile);
            out.print(gen.generate());
        } catch (IOException ex) {
        } finally {
            try {
                outFile.close();
            } catch (IOException ex) {
            }
        }
    }//GEN-LAST:event_menuItemXMLExportActionPerformed

    private void menuItemSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemSaveActionPerformed
        JFileChooser fc = new JFileChooser();
        FileFilter ff = new FileFilter() {

            @Override
            public boolean accept(File f) {
                return f.isDirectory() || f.getName().toLowerCase().endsWith(".dtm");
            }

            @Override
            public String getDescription() {
                return ".dtm files";
            }
        };
        fc.setFileFilter(ff);
        File f = null;
        if (fc.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            f = fc.getSelectedFile();
        } else {
            return;
        }

        try {
            FileOutputStream fileOut = new FileOutputStream(f);
            ObjectOutputStream out = new ObjectOutputStream(fileOut);
            ArrayList al = new ArrayList(Arrays.asList(panelModel.getComponents()));
            SavingWrapper s = new SavingWrapper(al, panelModel.getReferences());
            out.writeObject(s);
            out.close();
            fileOut.close();
        } catch (FileNotFoundException e) {
            System.out.println(e.toString());
        } catch (IOException e) {
            System.out.println(e.toString());
        }
    }//GEN-LAST:event_menuItemSaveActionPerformed

    private void menuItemOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemOpenActionPerformed
        JFileChooser fc = new JFileChooser();
        FileFilter ff = new FileFilter() {

            @Override
            public boolean accept(File f) {
                return f.isDirectory() || f.getName().toLowerCase().endsWith(".dtm");
            }

            @Override
            public String getDescription() {
                return ".dtm files";
            }
        };
        fc.setFileFilter(ff);
        File f = null;
        if (fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            f = fc.getSelectedFile();
        } else {
            return;
        }

        try {
            FileInputStream fileIn = new FileInputStream(f);
            ObjectInputStream in = new ObjectInputStream(fileIn);

            SavingWrapper s = (SavingWrapper) in.readObject();

            in.close();
            fileIn.close();
            panelModel.openNewProject(s);
            panelModel.setActiveTableComponent(null);
        } catch (ClassNotFoundException e) {
        } catch (FileNotFoundException e) {
        } catch (IOException e) {
        }
    }//GEN-LAST:event_menuItemOpenActionPerformed

    private void menuItemChooseSystemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemChooseSystemActionPerformed
        PluginChooser pch = new PluginChooser(labelPlugin.getText().substring(8, labelPlugin.getText().length()));
        if (JOptionPane.showConfirmDialog(this, pch, "Choose plugin", JOptionPane.OK_CANCEL_OPTION) == 0) {
            labelPlugin.setText("Loaded: " + pch.getPluginName());
            generator = pch.getGenerator();
            dbSpecificTypes.clear();
            if (pch.getDbSpecificTypes() != null) {
                dbSpecificTypes.add(pch.getDbSpecificTypes());
                setListOfDbSpecAttrByDefault();
            }
            initSpecificDataTypes();
            panelModel.transformAllAttributesToCurrentDataTypes();
            setButtonsByAttribute(null);
            panelModel.setActiveTableComponent(null);
            JOptionPane.showMessageDialog(this, "Loaded");
        }
    }//GEN-LAST:event_menuItemChooseSystemActionPerformed

    private void listSpecificDataTypesMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listSpecificDataTypesMouseClicked
        if (listSpecificDataTypes.getSelectedIndex() != -1) {
            listSqlDataTypes.clearSelection();
        }
        panelModel.setCurrentAttributeType((ISqlDataType) listSpecificDataTypes.getSelectedValue());
    }//GEN-LAST:event_listSpecificDataTypesMouseClicked

    private void menuItemImportDdlActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemImportDdlActionPerformed

        JFileChooser fc = new JFileChooser();
        FileFilter ff = new FileFilter() {

            @Override
            public boolean accept(File f) {
                return f.isDirectory() || f.getName().toLowerCase().endsWith(".sql");
            }

            @Override
            public String getDescription() {
                return ".sql files";
            }
        };
        fc.setFileFilter(ff);
        File f = null;
        if (fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            f = fc.getSelectedFile();
        } else {
            return;
        }

        try {
            if (generator == null) {
                generator = new DefaultGenerator();
            }
            ReverseWrapper rw = generator.reverseEngineer(
                    new Scanner(new FileInputStream(f)));
            panelModel.reverseEngineer(rw);
            panelModel.setActiveTableComponent(null);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_menuItemImportDdlActionPerformed

    private void btnRemoveForeignKeyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemoveForeignKeyActionPerformed
        panelModel.unsetForeignKey();
    }//GEN-LAST:event_btnRemoveForeignKeyActionPerformed

    private void formKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_formKeyPressed
    }//GEN-LAST:event_formKeyPressed

    private void toggleRemoveTableActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toggleRemoveTableActionPerformed
        if (!toggleRemoveTable.isSelected()) {
            panelModel.setMode(0);
            update(null, panelModel.getActiveTable());
        } else {
            panelModel.setMode(8);
            this.setButtonsByAttribute(null);
            panelModel.setActiveTableComponent(null);
            setButtonsByTable();
            this.setButtonsByMode();
        }
    }//GEN-LAST:event_toggleRemoveTableActionPerformed

    private void menuItemHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemHelpActionPerformed
        new ThreadStarter(this).start();
    }//GEN-LAST:event_menuItemHelpActionPerformed

    private void toggleNewTableIdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toggleNewTableIdActionPerformed
        if (toggleNewTableId.isSelected()) {
            panelModel.setMode(2);
            setButtonsByAttribute(null);
            panelModel.setActiveTableComponent(null);
            setButtonsByTable();
            setButtonsByMode();
        } else {
            panelModel.setMode(0);
            setButtonsByMode();
        }
    }//GEN-LAST:event_toggleNewTableIdActionPerformed

    private void spinnerArg1MouseClicked(MouseEvent e) {
        if ((Integer) spinnerArg1.getValue() < 1) {
            spinnerArg1.setValue(new Integer(1));
        }
        if (spinnerArg1.isEnabled()) {
            panelModel.setCurrentAttributeArgument1((Integer) spinnerArg1.getValue());
        }
    }

    private void spinnerArg2MouseClicked(MouseEvent e) {
        if ((Integer) spinnerArg2.getValue() < 1) {
            spinnerArg2.setValue(new Integer(1));
        }
        if (spinnerArg2.isEnabled()) {
            panelModel.setCurrentAttributeArgument2((Integer) spinnerArg2.getValue());
        }
    }

    public void update(Observable o, Object arg) {
        setButtonsByMode();
        setButtonsByTable();

        if (arg instanceof IAttribute) {
            setButtonsByAttribute((IAttribute) arg);
        } else {
            setButtonsByAttribute(null);
        }
        if (arg instanceof Integer) {
            if (((Integer) arg).intValue() == 9) {
                setButtonsSelectingTable();
            }
        }
    }

    private void setButtonsByMode() {
        toggleNewTable.setSelected(panelModel.getMode() == 1);
        toggleNewTableId.setSelected(panelModel.getMode() == 2);
        toggleRemoveTable.setSelected(panelModel.getMode() == 8);
        if (panelModel.getMode() != 0) {
            toggleNewTable.setEnabled(panelModel.getMode() == 1);
            toggleNewTableId.setEnabled(panelModel.getMode() == 2);
            toggleRemoveTable.setEnabled(panelModel.getMode() == 8);
        } else {
            toggleNewTable.setEnabled(true);
            toggleNewTableId.setEnabled(true);
            toggleRemoveTable.setEnabled(true);
        }
    }

    private void setButtonsByTable() {
        btnAddAttribute.setEnabled(panelModel.getActiveTable() != null);
    }

    private void setButtonsByAttribute(IAttribute attr) {
        toggleNewTable.setEnabled(true);
        toggleNewTableId.setEnabled(true);
        toggleRemoveTable.setEnabled(true);
        if ((attr == null) || (panelModel.getListOfSelectedAttributes().size() > 1)
                || (panelModel.getCanSelectMoreAttrs())) {
            btnRemoveAttribute.setEnabled(false);
            btnMoveUp.setEnabled(false);
            btnMoveDown.setEnabled(false);
            toggleAutoInc.setEnabled(false);
            toggleForeignKey.setEnabled(false);
            btnRemoveForeignKey.setEnabled(false);
            toggleNotNull.setEnabled(false);
            togglePrimaryKey.setEnabled(false);
            toggleUnique.setEnabled(false);
            listSqlDataTypes.setEnabled(false);
            listSqlDataTypes.clearSelection();
            setListOfDbSpecAttrByDefault();
            listSpecificDataTypes.clearSelection();
            spinnerArg1.setEnabled(false);
            spinnerArg2.setEnabled(false);
            spinnerArg1.setValue(new Integer(0));
            spinnerArg2.setValue(new Integer(0));
            labelDataTypeArg1.setText("");
            labelDataTypeArg2.setText("");
        } else {
            btnRemoveAttribute.setEnabled(true);
            toggleAutoInc.setEnabled(true);
            toggleForeignKey.setEnabled(true);
            toggleNotNull.setEnabled(true);
            togglePrimaryKey.setEnabled(true);
            toggleUnique.setEnabled(true);
            btnMoveUp.setEnabled(true);
            btnMoveDown.setEnabled(true);

            listSqlDataTypes.setEnabled(true);
            listSqlDataTypes.clearSelection();
            listSpecificDataTypes.clearSelection();
            listSqlDataTypes.setSelectedValue(attr.getDataType(), true);
            setListOfDbSpecAttrByDefault();
            listSpecificDataTypes.setSelectedValue(attr.getDataType(), true);
            spinnerArg1.setEnabled(!attr.getDataType().getArgs().isEmpty() && !attr.getArguments().isEmpty());
            spinnerArg2.setEnabled(attr.getDataType().getArgs().size() > 1 && attr.getArguments().size() > 1);
            if (spinnerArg1.isEnabled()) {
                spinnerArg1.setValue(attr.getArguments().get(0));
                labelDataTypeArg1.setText(attr.getDataType().getArgs().get(0));
            } else {
                spinnerArg1.setValue(0);
                labelDataTypeArg1.setText(" ");
            }
            if (spinnerArg2.isEnabled()) {
                //  JOptionPane.showMessageDialog(this, ""+" "+attr.getName()+attr.getDataType().getName()+"\nargs: "+attr.getArguments().size()+"\ndata type args: "+attr.getDataType().getArgs().size());
                spinnerArg2.setValue(attr.getArguments().get(1));
                labelDataTypeArg2.setText(attr.getDataType().getArgs().get(1));
            } else {
                spinnerArg2.setValue(0);
                labelDataTypeArg2.setText(" ");
            }

            toggleAutoInc.setSelected(attr.isAutoIncrement());
            //    toggleForeignKey.setSelected(!attr.getForeignKey().isEmpty());
            toggleForeignKey.setSelected(false);
            btnRemoveForeignKey.setEnabled(!attr.getForeignKey().isEmpty());
            toggleNotNull.setSelected(attr.isNotNull());
            togglePrimaryKey.setSelected(attr.isPrimaryKey());
            toggleUnique.setSelected(attr.isUnique());

            if (attr.isPrimaryKey()) {
                toggleUnique.setEnabled(false);
                toggleUnique.setSelected(true);
                toggleNotNull.setEnabled(false);
                toggleNotNull.setSelected(true);
            }
            if (attr.isUnique()) {
                toggleNotNull.setEnabled(false);
                toggleNotNull.setSelected(true);
            }
            try {
                if (panelModel.getActiveTable().getTable().getAttributeList().indexOf(attr) == 0) {
                    btnMoveUp.setEnabled(false);
                }
            } catch (NullPointerException e) {
            }
            try {
                if (panelModel.getActiveTable().getTable().getAttributeList().indexOf(attr)
                        == panelModel.getActiveTable().getTable().getAttributeList().size() - 1) {
                    btnMoveDown.setEnabled(false);
                }
            } catch (NullPointerException e) {
            }
            if (!attr.getForeignKey().isEmpty()) {
                btnRemoveAttribute.setEnabled(false);
                listSqlDataTypes.setEnabled(false);
                setListOfDbSpecAttrByDefault();
                spinnerArg1.setEnabled(false);
                spinnerArg2.setEnabled(false);
            }
            if (panelModel.getActiveTable() != null) {
                for (ReferenceData ref : panelModel.getReferences()) {
                    ITable t = ref.getReference().getReferencedTable();
                    if (t == panelModel.getTableByAttribute(attr)) {
                        togglePrimaryKey.setEnabled(false);
                        if (attr.isPrimaryKey()) {
                            btnRemoveAttribute.setEnabled(false);
                            listSqlDataTypes.setEnabled(false);
                            setListOfDbSpecAttrByDefault();
                            spinnerArg1.setEnabled(false);
                            spinnerArg2.setEnabled(false);
                        }
                        break;
                    }
                }
            }

        }
        if (panelModel.getActiveTable() != null) {
            if ((panelModel.getListOfSelectedAttributes().size() > 1) || (panelModel.getCanSelectMoreAttrs())) {
                btnAddAttribute.setEnabled(false);
                toggleForeignKey.setEnabled(true);

                btnRemoveAttribute.setEnabled(false);
                for (ReferenceData refDat : panelModel.getReferences()) {
                    if ((refDat.getReference().getAttributeWithFK().containsAll(panelModel.getListOfSelectedAttributes()))) {
                        btnRemoveForeignKey.setEnabled(true);
                        break;
                    }
                }
            }
        }

    }

    private void setButtonsSelectingTable() {
        btnRemoveAttribute.setEnabled(false);
        btnMoveUp.setEnabled(false);
        btnMoveDown.setEnabled(false);
        toggleAutoInc.setEnabled(false);
        toggleNotNull.setEnabled(false);
        togglePrimaryKey.setEnabled(false);
        toggleUnique.setEnabled(false);
        listSqlDataTypes.setEnabled(false);
        listSqlDataTypes.clearSelection();
        setListOfDbSpecAttrByDefault();
        listSpecificDataTypes.clearSelection();
        spinnerArg1.setEnabled(false);
        spinnerArg2.setEnabled(false);
        spinnerArg1.setValue(new Integer(0));
        spinnerArg2.setValue(new Integer(0));
        labelDataTypeArg1.setText(" ");
        labelDataTypeArg2.setText(" ");
        toggleNewTable.setEnabled(false);
        toggleNewTableId.setEnabled(false);
        toggleRemoveTable.setEnabled(false);
        toggleForeignKey.setEnabled(true);
    }

    private void setCompletlyAllButtonsDisabled() {
        setButtonsSelectingTable();
        toggleForeignKey.setEnabled(false);
    }

    private void initDataTypes() {
        DefaultListModel lm = new DefaultListModel();
        for (ISqlDataType type : defaultTypes.getTypeList()) {
            lm.addElement(type);
        }
        listSqlDataTypes.setModel(lm);
    }

    private void initSpecificDataTypes() {
        DefaultListModel lm = new DefaultListModel();
        if (dbSpecificTypes.isEmpty()) {
            listSpecificDataTypes.setModel(lm);
            return;
        }
        for (ISqlDataType type : dbSpecificTypes.get(0).getTypeList()) {
            lm.addElement(type);
        }
        listSpecificDataTypes.setModel(lm);
    }

    private void setListOfDbSpecAttrByDefault() {
        if (dbSpecificTypes.isEmpty()) {
            listSpecificDataTypes.setEnabled(false);
            return;
        }
        listSpecificDataTypes.setEnabled(listSqlDataTypes.isEnabled());
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddAttribute;
    private javax.swing.JButton btnMoveDown;
    private javax.swing.JButton btnMoveUp;
    private javax.swing.JButton btnRemoveAttribute;
    private javax.swing.JButton btnRemoveForeignKey;
    private javax.swing.JMenuItem exportToPngItem;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenu jMenu5;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JToolBar.Separator jSeparator4;
    private javax.swing.JToolBar.Separator jSeparator5;
    private javax.swing.JToolBar.Separator jSeparator6;
    private javax.swing.JLabel labelDataTypeArg1;
    private javax.swing.JLabel labelDataTypeArg2;
    private javax.swing.JLabel labelPlugin;
    private javax.swing.JLabel labelSpecificTypes;
    private javax.swing.JList listSpecificDataTypes;
    private javax.swing.JList listSqlDataTypes;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenu menuChooseMode;
    private javax.swing.JMenu menuFile;
    private javax.swing.JMenu menuHelp;
    private javax.swing.JMenu menuImport;
    private javax.swing.JMenuItem menuItemChooseSystem;
    private javax.swing.JMenuItem menuItemExportDdl;
    private javax.swing.JMenuItem menuItemHelp;
    private javax.swing.JMenuItem menuItemImportDdl;
    private javax.swing.JMenuItem menuItemOpen;
    private javax.swing.JMenuItem menuItemSave;
    private javax.swing.JMenuItem menuItemXMLExport;
    private javax.swing.JPanel panelNewTable;
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JSpinner spinnerArg1;
    private javax.swing.JSpinner spinnerArg2;
    private javax.swing.JToggleButton toggleAutoInc;
    private javax.swing.JToggleButton toggleForeignKey;
    private javax.swing.JToggleButton toggleNewTable;
    private javax.swing.JToggleButton toggleNewTableId;
    private javax.swing.JToggleButton toggleNotNull;
    private javax.swing.JToggleButton togglePrimaryKey;
    private javax.swing.JToggleButton toggleRemoveTable;
    private javax.swing.JToggleButton toggleUnique;
    private javax.swing.JToggleButton toogleHideRelationPoints;
    private javax.swing.JToolBar toolBarTop;
    // End of variables declaration//GEN-END:variables
}
