/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * panelModel.java
 *
 * Created on 22.4.2011, 14:33:58
 */
package graphics;

import InputOutput.ReverseWrapper;
import InputOutput.SaveRef;
import InputOutput.SaveTable;
import InputOutput.SavingWrapper;
import init.DefaultDataTypes;
import init.IDataTypes;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Stroke;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseMotionListener;
import java.awt.geom.Line2D;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Observable;
import java.util.Observer;
import javax.swing.ImageIcon;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import structures.Attribute;
import structures.IAttribute;
import structures.IReference;
import structures.ISqlDataType;
import structures.ITable;
import structures.Table;

/**
 *
 * @author mates
 */
public class PanelModel extends javax.swing.JPanel implements Observer, Serializable {

    private int mode = 0;
    private Map<ITable, Point> tablePositions;
    private int tableSequence = 1;
    private Observ observ = new Observ();
    private DefaultDataTypes defaultTypes;
    private ArrayList<IDataTypes> dbSpecificTypes;
    private ArrayList<ReferenceData> references = new ArrayList<ReferenceData>();
    private ImageIcon[][] relationSymbols = new ImageIcon[8][2];
    private ArrayList<IAttribute> selectedAttributes = new ArrayList<IAttribute>();
    private boolean canSelectMoreAttributes = false;
    private ArrayList<IReference> selectedRelation = new ArrayList<IReference>();
    private Map<ReferenceData, Rectangle> referenceTogglePoints = new HashMap<ReferenceData, Rectangle>();
    private boolean showReferencePoints = true;
    private Point positionChange = null;

    /** Creates new form panelModel */
    public PanelModel(MainFrame mainFrame, DefaultDataTypes defaultTypes, ArrayList<IDataTypes> dbSpecificTypes) {
        initComponents();
        tablePositions = new HashMap<ITable, Point>();
        this.defaultTypes = defaultTypes;
        this.dbSpecificTypes = dbSpecificTypes;

        relationSymbols[0][0] = new ImageIcon(getClass().getResource("/resources/n_relation_1.png"));
        relationSymbols[1][0] = new ImageIcon(getClass().getResource("/resources/n_relation_2.png"));
        relationSymbols[2][0] = new ImageIcon(getClass().getResource("/resources/n_relation_3.png"));
        relationSymbols[3][0] = new ImageIcon(getClass().getResource("/resources/n_relation_4.png"));
        relationSymbols[4][0] = new ImageIcon(getClass().getResource("/resources/one_relation_1.png"));
        relationSymbols[5][0] = new ImageIcon(getClass().getResource("/resources/one_relation_2.png"));
        relationSymbols[6][0] = new ImageIcon(getClass().getResource("/resources/one_relation_3.png"));
        relationSymbols[7][0] = new ImageIcon(getClass().getResource("/resources/one_relation_4.png"));
        relationSymbols[0][1] = new ImageIcon(getClass().getResource("/resources/n_relation_11.png"));
        relationSymbols[1][1] = new ImageIcon(getClass().getResource("/resources/n_relation_12.png"));
        relationSymbols[2][1] = new ImageIcon(getClass().getResource("/resources/n_relation_13.png"));
        relationSymbols[3][1] = new ImageIcon(getClass().getResource("/resources/n_relation_14.png"));
        relationSymbols[4][1] = new ImageIcon(getClass().getResource("/resources/one_relation_11.png"));
        relationSymbols[5][1] = new ImageIcon(getClass().getResource("/resources/one_relation_12.png"));
        relationSymbols[6][1] = new ImageIcon(getClass().getResource("/resources/one_relation_13.png"));
        relationSymbols[7][1] = new ImageIcon(getClass().getResource("/resources/one_relation_14.png"));


        observ.addObserver(mainFrame);
        addMouseListener(returnPanelModelMouseListener());
        addMouseMotionListener(returnPanelModelMouseMotionListener());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setBackground(new java.awt.Color(254, 254, 254));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    public void setMode(int i) {
        this.mode = i;
    }

    public int getMode() {
        return mode;
    }

    private PanelModel getInstance() {
        return this;
    }

    public boolean isShowReferencePoints() {
        return showReferencePoints;
    }

    public void setShowReferencePoints(boolean showReferencePoints) {
        this.showReferencePoints = showReferencePoints;
    }

    public TableComponent getActiveTable() {
        for (int i = 0; i < getComponentCount(); i++) {
            if (((TableComponent) getComponent(i)).isActive()) {
                return (TableComponent) getComponent(i);
            }
        }
        return null;
    }

    public void setCanSelectMoreAttributes(boolean can) {
        this.canSelectMoreAttributes = can;
    }

    public boolean getCanSelectMoreAttrs() {
        return canSelectMoreAttributes;
    }

    public ArrayList<IAttribute> getListOfSelectedAttributes() {
        return selectedAttributes;
    }

    public ArrayList<ReferenceData> getReferences() {
        return references;
    }

    private MouseListener returnPanelModelMouseListener() {
        return new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent e) {
                // 1 - table create
                // 2 - table create with id
                // 9 - choosing table


                switch (mode) {
                    case 0:
                        setActiveTableComponent(null);
                        observ.notifyObservers();
                        break;
                    case 1:
                        createNewTableAtPoint(e.getPoint());
                        mode = 0;
                        observ.notifyObservers(getInstance());
                        break;
                    case 2:
                        TableComponent t = createNewTableAtPoint(e.getPoint());
                        t.getTable().getAttributeList().add(
                                new Attribute("id", defaultTypes.getTypeList().get(8)));
                        t.getTable().getAttributeList().get(0).setPrimaryKey(true);
                        t.sortAttributes();
                        mode = 0;
                        observ.notifyObservers(getInstance());
                }
            }

            private void doPop(MouseEvent e, Point p, ReferenceData refData) {
                PopUpMenu menu = new PopUpMenu(p, refData);
                menu.show(e.getComponent(), e.getX(), e.getY());
            }

            @Override
            public void mousePressed(MouseEvent e) {

                if (e.getButton() == MouseEvent.BUTTON3) {
                    if (showReferencePoints) {
                        for (ReferenceData referenceData : references) {
                            if (referenceTogglePoints.get(referenceData) == null) {
                                continue;
                            }
                            if ((referenceTogglePoints.get(referenceData)).contains(e.getPoint())) {
                                referenceData.setAutoRoute(false);
                                referenceData.getPoints().add(
                                        new Point(referenceTogglePoints.get(referenceData).x + 4,
                                        referenceTogglePoints.get(referenceData).y + 4));
                                repaint();
                                return;
                            }
                        }
                        if (e.isPopupTrigger()) {
                            for (ReferenceData referenceData : references) {
                                for (Point p : referenceData.getPoints()) {
                                    Rectangle r = new Rectangle(p.x - 4, p.y - 4, 8, 8);
                                    if (r.contains(e.getPoint())) {
                                        doPop(e, p, referenceData);
                                        return;
                                    }
                                }
                            }
                        }

                    }

                }
                if (e.getButton() != MouseEvent.BUTTON1) {
                    return;
                }
                if (showReferencePoints) {
                    for (ReferenceData referenceData : references) {
                        for (Point p : referenceData.getPoints()) {
                            Rectangle r = new Rectangle(p.x - 4, p.y - 4, 8, 8);
                            if (r.contains(e.getPoint())) {
                                positionChange = p;
                                return;
                            }
                        }
                    }
                }

            }

            @Override
            public void mouseReleased(MouseEvent e) {
                positionChange = null;

//                if (e.isPopupTrigger()) {
//                    doPop(e, null);
//                }
            }
        };
    }

    private MouseMotionListener returnPanelModelMouseMotionListener() {
        return new MouseMotionAdapter() {

            @Override
            public void mouseMoved(MouseEvent e) {
            }

            @Override
            public void mouseDragged(MouseEvent e) {
                if (positionChange != null) {
                    positionChange.setLocation(e.getPoint().getLocation());
                    repaint();
                }
            }
        };
    }

    public void deleteTableComponent(TableComponent tc) {
        if (tc != null) {
            boolean canBeDeleted = true;
            for (ReferenceData ref : references) {
                if (ref.getReference().getReferencedTable() == tc.getTable()) {
                    canBeDeleted = false;
                    break;
                }
                if (ref.getReference().getTableWithFK() == tc.getTable()) {
                    canBeDeleted = false;
                    break;
                }
            }
            if (canBeDeleted) {
                setMode(0);
                getInstance().remove(tc);
                setActiveTableComponent(null);
                observ.notifyObservers(null);
            }
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    private TableComponent createNewTableAtPoint(Point point) {
        TableComponent t = new TableComponent(
                new Table("table_" + tableSequence++),
                this,
                ((MainFrame) (getParent().getParent().getParent().getParent().getParent().getParent())),
                defaultTypes,
                dbSpecificTypes);
        add(
                t);
        t.setBounds(point.x, point.y, 250, 120);
        setActiveTableComponent(
                t);
        setComponentZOrder(
                t, 0);
        return t;

    }

    private TableComponent createTableAtPoint(ITable table, Point point, Dimension size) {
        transformAttributes(table);
        TableComponent t = new TableComponent(
                table,
                this,
                ((MainFrame) (getParent().getParent().getParent().getParent().getParent().getParent())),
                defaultTypes,
                dbSpecificTypes);
        add(
                t);
        t.setBounds(point.x, point.y, size.width, size.height);
        t.getRightDownLabel().setLocation(size.width - 21, size.height - 21);
        setActiveTableComponent(
                t);
        setComponentZOrder(
                t, 0);


        return t;


    }

    public ITable getTableByAttribute(IAttribute attr) {
        for (int i = 0; i
                < getComponentCount(); i++) {
            if (getComponent(i) instanceof TableComponent) {
                if (((TableComponent) getComponent(i)).getTable().getAttributeList().indexOf(attr) > -1) {
                    return ((TableComponent) getComponent(i)).getTable();


                }
            }
        }
        return null;


    }

    public void update(Observable o, Object arg) {
        if (!canSelectMoreAttributes) {
            selectedAttributes.clear();


        } else {
            canSelectMoreAttributes = false;


        }
        if (arg instanceof TableComponent) {
            setActiveTableComponent((TableComponent) arg);
            setMode(
                    0);


            try {
                setComponentZOrder((TableComponent) arg, 0);


            } catch (IllegalArgumentException e) {
            }
        }
        if (arg instanceof IAttribute) {
            selectedAttributes.add((IAttribute) arg);


            for (int i = 0; i
                    < getComponentCount(); i++) {
                if (((TableComponent) getComponent(i)).setSelectedAttribute((IAttribute) arg)) {
                    setActiveTableComponent(((TableComponent) getComponent(i)));


                    if (selectedAttributes.size() > 1) {
                        ((TableComponent) getComponent(i)).setSelectedAttributes(selectedAttributes);


                    }
                }
            }
        }
    }

    public void setActiveTableComponent(TableComponent tableComponent) {
        for (int i = 0; i
                < getComponentCount(); i++) {
            if (tableComponent != getComponent(i)) {
                ((TableComponent) getComponent(i)).setActive(false);


                ((TableComponent) getComponent(i)).setSelectedAttribute(null);


            } else {
                tableComponent.setActive(true);


            }
        }
        repaint();


    }

    void addNewAttributeToActiveTable() {
        try {
            getActiveTable().addNewAttribute();


        } catch (NullPointerException e) {
        }
    }

    void setCurrentAttributeAs(int i, boolean select) {
        getActiveTable().setSelectedAttributeAs(i, select);


    }

    void setCurrentAttributeType(ISqlDataType iSqlDataType) {
        getActiveTable().setCurrentAttributeType(iSqlDataType);


    }

    void setCurrentAttributeArgument1(Integer integer) {
        if (getActiveTable() == null) {
            return;


        }
        getActiveTable().setCurrentAttributeArgument1(integer);


    }

    void setCurrentAttributeArgument2(Integer integer) {
        if (getActiveTable() == null) {
            return;


        }
        getActiveTable().setCurrentAttributeArgument2(integer);


    }

    void deleteCurentAttribute() {
        getActiveTable().deleteCurrentAttribute();


    }

    void moveCurrentAttributeUp() {
        getActiveTable().moveCurrentAttributeUp();


    }

    void moveCurrentAttributeDown() {
        getActiveTable().moveCurrentAttributeDown();


    }

    ReferenceData getReferenceData(IReference ref) {
        for (ReferenceData referenceData : references) {
            if (referenceData.getReference() == ref) {
                return referenceData;


            }
        }
        return null;


    }

    void setCurrentAttributeAsForeignKey(boolean selected) {
        if (selected) {
            mode = 9;
            observ.notifyObservers(new Integer(mode));


        } else {
            mode = 0;
            observ.notifyObservers(getActiveTable().getSelectedIAttribute());


        }
    }

    private TableComponent getTableComponent(ITable table) {
        for (int i = 0; i
                < getComponentCount(); i++) {
            if (getComponent(i) instanceof TableComponent) {
                if (table == ((TableComponent) getComponent(i)).getTable()) {
                    return (TableComponent) getComponent(i);


                }
            }
        }
        return null;


    }

    public void showRelationShip(IReference relation, boolean show) {
        selectedRelation.clear();


        if (show) {
            selectedRelation.add(relation);


        } else {
            selectedRelation.clear();


        }
        for (IAttribute attr : relation.getAttributeWithFK()) {
            getTableComponent(getTableByAttribute(attr)).showFKComponents(relation.getAttributeWithFK(), show);


        }
        repaint();


    }

    public void showRelationShips(ArrayList<IReference> relation, boolean show) {
        selectedRelation.clear();


        if (show) {
            for (IReference iReference : relation) {
                selectedRelation.add(iReference);


            }
        } else {
            selectedRelation.clear();


        }
        for (IReference iReference : relation) {
            for (IAttribute attr : iReference.getAttributeWithFK()) {
                getTableComponent(getTableByAttribute(attr)).showFKComponents(iReference.getAttributeWithFK(), show);


            }
        }
        repaint();


    }

    @Override
    public Dimension getPreferredSize() {
        int x = 0, y = 0;


        for (int i = 0; i
                < getComponentCount(); i++) {
            if (getComponent(i).getX() + getComponent(i).getWidth() > x) {
                x = getComponent(i).getX() + getComponent(i).getWidth();


            }
            if (getComponent(i).getY() + getComponent(i).getHeight() > y) {
                y = getComponent(i).getY() + getComponent(i).getHeight();


            }
        }
        return new Dimension(x + 5, y + 5);


    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);

        referenceTogglePoints.clear();



        for (ReferenceData referenceData : references) {
            Point relPos;
            Point relPos2;


            int obr = 0;


            int oneSideImg = 0;


            boolean unique = false;


            boolean not_null = false;


            boolean primary_key = false;


            boolean all_unique = true;


            boolean all_not_null = true;


            boolean all_primary_key = true;


            boolean all_unique_or_primaryKey = true;


            for (IAttribute attr : referenceData.getReference().getAttributeWithFK()) {
                if (attr.isUnique()) {
                    unique = true;


                } else {
                    all_unique = false;


                }
                if (attr.isNotNull()) {
                    not_null = true;


                } else {
                    all_not_null = false;


                }
                if (attr.isPrimaryKey()) {
                    primary_key = true;


                } else {
                    all_primary_key = false;


                }
                if (!attr.isUnique() && !attr.isPrimaryKey()) {
                    all_unique_or_primaryKey = false;


                }
            }

            all_primary_key = (all_primary_key
                    && referenceData.getReference().getTableWithFK().getPrimaryKey().size() == referenceData.getReference().getAttributeWithFK().size());


            if (all_unique_or_primaryKey) {
                if (!referenceData.getReference().getAttributeWithFK().containsAll(referenceData.getReference().getTableWithFK().getPrimaryKey())) {
                    all_unique_or_primaryKey = false;
                }


            }
            Stroke drawingStroke =
                    new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 0, new float[]{9}, 0);
            Graphics2D g2 = (Graphics2D) g;
            TableComponent tpk = getTableComponent(
                    referenceData.getReference().getTableWithFK());
            TableComponent rt = getTableComponent(
                    referenceData.getReference().getReferencedTable());



            int tpkCX = tpk.getX() + tpk.getWidth() / 2;


            int tpkCY = tpk.getY() + tpk.getHeight() / 2;


            int rtCX = rt.getX() + rt.getWidth() / 2;


            int rtCY = rt.getY() + rt.getHeight() / 2;


            if (referenceData.isAutoRoute() || referenceData.getPoints().isEmpty()) {
                if (selectedRelation.contains(referenceData.getReference())) {
                    g2.setColor(Color.red);


                } else {
                    g2.setColor(Color.black);


                }
                Line2D l1, l2, l3;

                double p1 = -((double) tpk.getHeight() / (double) tpk.getWidth()) * rtCX;
                p1 += tpk.getY() + tpk.getHeight() * (1 + ((double) tpk.getX() / (double) tpk.getWidth()));
                p1 -= rtCY;
                double p2 = ((double) tpk.getHeight() / (double) tpk.getWidth()) * rtCX;
                p2 += tpk.getY() - ((double) tpk.getHeight() / (double) tpk.getWidth())*tpk.getX();
                p2 -= rtCY;

                if (p1 < 0 && p2 > 0) {
                    l1 = new Line2D.Double(
                            tpk.getX() + tpk.getWidth(),
                            tpk.getY() + (tpk.getHeight() / 2),
                            (tpk.getX() + tpk.getWidth() + rt.getX()) / 2,
                            tpk.getY() + (tpk.getHeight() / 2));
                    l2 = new Line2D.Double(
                            (tpk.getX() + tpk.getWidth() + rt.getX()) / 2,
                            tpk.getY() + (tpk.getHeight() / 2),
                            (tpk.getX() + tpk.getWidth() + rt.getX()) / 2,
                            rt.getY() + (rt.getHeight() / 2));
                    l3 = new Line2D.Double(
                            (tpk.getX() + tpk.getWidth() + rt.getX()) / 2,
                            rt.getY() + (rt.getHeight() / 2),
                            rt.getX(),
                            rt.getY() + (rt.getHeight() / 2));
                    relPos = new Point(tpk.getX() + tpk.getWidth(), tpk.getY() + (tpk.getHeight() / 2) - 10);
                    relPos2 = new Point(rt.getX() - 29, (rt.getY() + rt.getHeight() / 2) - 10);
                    obr = 0;
                    referenceTogglePoints.put(referenceData,
                            new Rectangle(
                            (tpk.getX() + tpk.getWidth() + rt.getX()) / 2 - 4,
                            (tpk.getY() + (tpk.getHeight() / 2) + rt.getY() + (rt.getHeight() / 2)) / 2 - 4,
                            8, 8));


                } else if (p1 >= 0 && p2 <= 0) {

                    l1 = new Line2D.Double(
                            rt.getX() + rt.getWidth(),
                            rt.getY() + (rt.getHeight() / 2),
                            (rt.getX() + rt.getWidth() + tpk.getX()) / 2,
                            rt.getY() + (rt.getHeight() / 2));
                    l2 = new Line2D.Double(
                            (rt.getX() + rt.getWidth() + tpk.getX()) / 2,
                            rt.getY() + (rt.getHeight() / 2),
                            (rt.getX() + rt.getWidth() + tpk.getX()) / 2,
                            tpk.getY() + (tpk.getHeight() / 2));
                    l3 = new Line2D.Double(
                            (rt.getX() + rt.getWidth() + tpk.getX()) / 2,
                            tpk.getY() + (tpk.getHeight() / 2),
                            tpk.getX(),
                            tpk.getY() + (tpk.getHeight() / 2));
                    relPos = new Point(tpk.getX() - 29, tpk.getY() + (tpk.getHeight() / 2) - 10);
                    relPos2 = new Point(rt.getX() + rt.getWidth(), (rt.getY() + rt.getHeight() / 2) - 10);
                    obr = 1;
                    referenceTogglePoints.put(referenceData,
                            new Rectangle(
                            (rt.getX() + rt.getWidth() + tpk.getX()) / 2 - 4,
                            (rt.getY() + (rt.getHeight() / 2) + tpk.getY() + (tpk.getHeight() / 2)) / 2 - 4,
                            8, 8));


                } else if (p1 > 0 && p2 > 0) {
                    l1 = new Line2D.Double(
                            rt.getX() + (rt.getWidth() / 2),
                            rt.getY() + rt.getHeight(),
                            rt.getX() + (rt.getWidth() / 2),
                            (rt.getY() + rt.getHeight() + tpk.getY()) / 2);
                    l2 = new Line2D.Double(
                            rt.getX() + (rt.getWidth() / 2),
                            (rt.getY() + rt.getHeight() + tpk.getY()) / 2,
                            tpk.getX() + (tpk.getWidth() / 2),
                            (rt.getY() + rt.getHeight() + tpk.getY()) / 2);
                    l3 = new Line2D.Double(
                            tpk.getX() + (tpk.getWidth() / 2),
                            (rt.getY() + rt.getHeight() + tpk.getY()) / 2,
                            tpk.getX() + (tpk.getWidth() / 2),
                            tpk.getY());
                    relPos = new Point(tpk.getX() + (tpk.getWidth() / 2) - 10, tpk.getY() - 29);
                    relPos2 = new Point(rt.getX() + (rt.getWidth() / 2) - 10, rt.getY() + rt.getHeight());
                    obr = 2;
                    referenceTogglePoints.put(referenceData,
                            new Rectangle(
                            (rt.getX() + (rt.getWidth() / 2) + tpk.getX() + (tpk.getWidth() / 2)) / 2 - 4,
                            (rt.getY() + rt.getHeight() + tpk.getY()) / 2 - 4,
                            8, 8));


                } else {
                    l1 = new Line2D.Double(
                            tpk.getX() + (tpk.getWidth() / 2),
                            tpk.getY() + tpk.getHeight(),
                            tpk.getX() + (tpk.getWidth() / 2),
                            (tpk.getY() + tpk.getHeight() + rt.getY()) / 2);
                    l2 = new Line2D.Double(
                            tpk.getX() + (tpk.getWidth() / 2),
                            (tpk.getY() + tpk.getHeight() + rt.getY()) / 2,
                            rt.getX() + (rt.getWidth() / 2),
                            (tpk.getY() + tpk.getHeight() + rt.getY()) / 2);
                    l3 = new Line2D.Double(
                            rt.getX() + (rt.getWidth() / 2),
                            (tpk.getY() + tpk.getHeight() + rt.getY()) / 2,
                            rt.getX() + (rt.getWidth() / 2),
                            rt.getY());
                    relPos = new Point(tpk.getX() + (tpk.getWidth() / 2) - 10, tpk.getY() + tpk.getHeight());
                    relPos2 = new Point(rt.getX() + (rt.getWidth() / 2) - 10, rt.getY() - 29);
                    obr = 3;
                    referenceTogglePoints.put(referenceData,
                            new Rectangle(
                            (tpk.getX() + (tpk.getWidth() / 2) + rt.getX() + (rt.getWidth() / 2)) / 2 - 4,
                            (tpk.getY() + tpk.getHeight() + rt.getY()) / 2 - 4,
                            8, 8));


                }
                if (!primary_key) {
                    g2.setStroke(drawingStroke);


                }
                g2.draw(l1);
                g2.draw(l2);
                g2.draw(l3);
                g2.setStroke(new BasicStroke());


                int whiteOrRed = 0;


                if (selectedRelation.contains(referenceData.getReference())) {
                    whiteOrRed = 1;


                }

                if (!all_unique && !all_primary_key && !all_unique_or_primaryKey) {
                    g.drawImage(relationSymbols[obr][whiteOrRed].getImage(), relPos.x, relPos.y, this);


                }
                oneSideImg = 6 + ((obr > 1) ? 1 : 0);



                if (primary_key || unique || not_null) {
                    oneSideImg -= 2;


                }
                g.drawImage(relationSymbols[oneSideImg][whiteOrRed].getImage(), relPos2.x, relPos2.y, this);


                if (showReferencePoints) {
                    g2.setColor(Color.black);
                    g2.fill(referenceTogglePoints.get(referenceData));
                    g2.draw(referenceTogglePoints.get(referenceData));


                }

                // pokud je auto-route

            } else {
                relPos = new Point();
                relPos2 = new Point();
                g.setColor(Color.black);
                Point firstPoint = referenceData.getPoints().get(0);
                Point lastPoint = referenceData.getPoints().get(referenceData.getPoints().size() - 1);
                Point lineStart, lineEnd;
                Point fkTableStartLine;


                if (tpkCX - firstPoint.x <= 0 && Math.abs(tpkCY - firstPoint.y) < Math.abs(tpkCX - firstPoint.x)) {
                    if (firstPoint.y < tpk.getY() + 10) {
                        lineStart = new Point(tpk.getX() + tpk.getWidth() + 29, tpk.getY() + 10);


                    } else if (firstPoint.y > tpk.getY() + tpk.getHeight() - 10) {
                        lineStart = new Point(tpk.getX() + tpk.getWidth() + 29, tpk.getY() + tpk.getHeight() - 10);


                    } else {
                        lineStart = new Point(tpk.getX() + tpk.getWidth() + 29, firstPoint.y);


                    }
                    obr = 0;
                    fkTableStartLine = new Point(tpk.getX() + tpk.getWidth(), lineStart.y);
                    relPos.x = tpk.getX() + tpk.getWidth();
                    relPos.y = lineStart.y - 10;


                } else if (tpkCX - firstPoint.x > 0 && Math.abs(tpkCY - firstPoint.y) < Math.abs(tpkCX - firstPoint.x)) {
                    if (firstPoint.y < tpk.getY() + 10) {
                        lineStart = new Point(tpk.getX() - 29, tpk.getY() + 10);


                    } else if (firstPoint.y > tpk.getY() + tpk.getHeight() - 10) {
                        lineStart = new Point(tpk.getX() - 29, tpk.getY() + tpk.getHeight() - 10);


                    } else {
                        lineStart = new Point(tpk.getX() - 29, firstPoint.y);


                    }
                    obr = 1;
                    fkTableStartLine = new Point(tpk.getX(), lineStart.y);
                    relPos.x = tpk.getX() - 29;
                    relPos.y = lineStart.y - 10;


                } else if (tpkCY - firstPoint.y > 0) {
                    if (firstPoint.x < tpk.getX() + 10) {
                        lineStart = new Point(tpk.getX() + 10, tpk.getY() - 29);


                    } else if (firstPoint.x > tpk.getX() + tpk.getWidth() - 10) {
                        lineStart = new Point(tpk.getX() + tpk.getWidth() - 10, tpk.getY() - 29);


                    } else {
                        lineStart = new Point(firstPoint.x, tpk.getY() - 29);


                    }
                    obr = 2;
                    fkTableStartLine = new Point(lineStart.x, tpk.getY());
                    relPos.x = lineStart.x - 10;
                    relPos.y = tpk.getY() - 29;


                } else {
                    if (firstPoint.x < tpk.getX() + 10) {
                        lineStart = new Point(tpk.getX() + 10, tpk.getY() + tpk.getHeight() + 29);


                    } else if (firstPoint.x > tpk.getX() + tpk.getWidth() - 10) {
                        lineStart = new Point(tpk.getX() + tpk.getWidth() - 10, tpk.getY() + tpk.getHeight() + 29);


                    } else {
                        lineStart = new Point(firstPoint.x, tpk.getY() + tpk.getHeight() + 29);


                    }
                    obr = 3;
                    fkTableStartLine = new Point(lineStart.x, tpk.getY() + tpk.getHeight());
                    relPos.x = lineStart.x - 10;
                    relPos.y = tpk.getY() + tpk.getHeight();


                }

                if (rtCX - lastPoint.x <= 0 && Math.abs(rtCY - lastPoint.y) < Math.abs(rtCX - lastPoint.x)) {
                    if (lastPoint.y < rt.getY() + 10) {
                        lineEnd = new Point(rt.getX() + rt.getWidth() + 29, rt.getY() + 10);


                    } else if (lastPoint.y > rt.getY() + rt.getHeight() - 10) {
                        lineEnd = new Point(rt.getX() + rt.getWidth() + 29, rt.getY() + rt.getHeight() - 10);


                    } else {
                        lineEnd = new Point(rt.getX() + rt.getWidth() + 29, lastPoint.y);


                    }
                    oneSideImg = 0;
                    relPos2.x = rt.getX() + rt.getWidth();
                    relPos2.y = lineEnd.y - 10;


                } else if (rtCX - lastPoint.x > 0 && Math.abs(rtCY - lastPoint.y) < Math.abs(rtCX - lastPoint.x)) {
                    if (lastPoint.y < rt.getY() + 10) {
                        lineEnd = new Point(rt.getX() - 29, rt.getY() + 10);


                    } else if (lastPoint.y > rt.getY() + rt.getHeight() - 10) {
                        lineEnd = new Point(rt.getX() - 29, rt.getY() + rt.getHeight() - 10);


                    } else {
                        lineEnd = new Point(rt.getX() - 29, lastPoint.y);


                    }
                    oneSideImg = 1;
                    relPos2.x = rt.getX() - 29;
                    relPos2.y = lineEnd.y - 10;


                } else if (rtCY - lastPoint.y > 0) {
                    if (lastPoint.x < rt.getX() + 10) {
                        lineEnd = new Point(rt.getX() + 10, rt.getY() - 29);


                    } else if (lastPoint.x > rt.getX() + rt.getWidth() - 10) {
                        lineEnd = new Point(rt.getX() + rt.getWidth() - 10, rt.getY() - 29);


                    } else {
                        lineEnd = new Point(lastPoint.x, rt.getY() - 29);


                    }
                    oneSideImg = 2;
                    relPos2.x = lineEnd.x - 10;
                    relPos2.y = rt.getY() - 29;


                } else {
                    if (lastPoint.x < rt.getX() + 10) {
                        lineEnd = new Point(rt.getX() + 10, rt.getY() + rt.getHeight() + 29);


                    } else if (lastPoint.x > rt.getX() + rt.getWidth() - 10) {
                        lineEnd = new Point(rt.getX() + rt.getWidth() - 10, rt.getY() + rt.getHeight() + 29);


                    } else {
                        lineEnd = new Point(lastPoint.x, rt.getY() + rt.getHeight() + 29);


                    }
                    oneSideImg = 3;
                    relPos2.x = lineEnd.x - 10;
                    relPos2.y = rt.getY() + rt.getHeight();


                }
                int whiteOrRed = 0;


                if (selectedRelation.contains(referenceData.getReference())) {
                    whiteOrRed = 1;


                }

                if (!all_unique && !all_primary_key && !all_unique_or_primaryKey) {
                    g.drawImage(relationSymbols[obr][whiteOrRed].getImage(), relPos.x, relPos.y, this);


                }
                oneSideImg = 6 + ((oneSideImg > 1) ? 1 : 0);



                if (primary_key || unique || not_null) {
                    oneSideImg -= 2;


                }

                g.drawImage(relationSymbols[oneSideImg][whiteOrRed].getImage(), relPos2.x, relPos2.y, this);



                if (selectedRelation.contains(referenceData.getReference())) {
                    g2.setColor(Color.red);


                } else {
                    g2.setColor(Color.black);


                }
                g.drawLine(fkTableStartLine.x, fkTableStartLine.y, lineStart.x, lineStart.y);


                if (!primary_key) {
                    g2.setStroke(drawingStroke);


                }

                g.drawLine(lineStart.x,
                        lineStart.y,
                        referenceData.getPoints().get(0).x,
                        referenceData.getPoints().get(0).y);


                for (int i = 0; i
                        < referenceData.getPoints().size() - 1; i++) {
                    if (selectedRelation.contains(referenceData.getReference())) {
                        g2.setColor(Color.red);


                    } else {
                        g2.setColor(Color.black);


                    }
                    if (!primary_key) {
                        g2.setStroke(drawingStroke);


                    }
                    Point p = referenceData.getPoints().get(i);
                    Point p2 = referenceData.getPoints().get(i + 1);
                    g.drawLine(p.x, p.y, p2.x, p2.y);


                    if (showReferencePoints) {
                        g2.setStroke(new BasicStroke());
                        g2.setColor(Color.white);
                        g.fillRect(
                                referenceData.getPoints().get(i).x - 4,
                                referenceData.getPoints().get(i).y - 4,
                                8,
                                8);
                        g2.setColor(Color.black);
                        g.drawRect(
                                referenceData.getPoints().get(i).x - 4,
                                referenceData.getPoints().get(i).y - 4,
                                8,
                                8);


                    }
                }

                if (selectedRelation.contains(referenceData.getReference())) {
                    g2.setColor(Color.red);


                } else {
                    g2.setColor(Color.black);


                }
                if (!primary_key) {
                    g2.setStroke(drawingStroke);


                }
                g.drawLine(lineEnd.x,
                        lineEnd.y,
                        referenceData.getPoints().get(referenceData.getPoints().size() - 1).x,
                        referenceData.getPoints().get(referenceData.getPoints().size() - 1).y);
                g2.setStroke(new BasicStroke());


                if (showReferencePoints) {
                    g2.setColor(Color.white);
                    g.fillRect(
                            referenceData.getPoints().get(referenceData.getPoints().size() - 1).x - 4,
                            referenceData.getPoints().get(referenceData.getPoints().size() - 1).y - 4,
                            8,
                            8);
                    g2.setColor(Color.black);
                    g.drawRect(
                            referenceData.getPoints().get(referenceData.getPoints().size() - 1).x - 4,
                            referenceData.getPoints().get(referenceData.getPoints().size() - 1).y - 4,
                            8,
                            8);


                }
            }
        }
    }

    void openNewProject(SavingWrapper s) {
        removeAll();
        referenceTogglePoints.clear();
        references.clear();



        for (SaveTable t : s.getTables()) {
            TableComponent tc = createTableAtPoint(t.getTable(), t.getLocation(), t.getSize());
            tc.sortAttributes();


        }
        for (SaveRef r : s.getRefs()) {
            ReferenceData rd = new ReferenceData(r.getRef(), r.getManPoints());
            references.add(rd);


        }
        observ.notifyObservers(null);
        repaint();


    }

    private void transformAttributes(ITable table) {
        for (IAttribute attr : table.getAttributeList()) {
            for (ISqlDataType dataType : defaultTypes.getTypeList()) {
                if (attr.getDataType().getName().compareTo(dataType.getName()) == 0) {
                    attr.setDataType(dataType);


                } else if (attr.getDataType().getShortCut().compareTo(dataType.getShortCut()) == 0) {
                    attr.setDataType(dataType);


                }
            }
            if (!dbSpecificTypes.isEmpty()) {
                for (ISqlDataType dataType : dbSpecificTypes.get(0).getTypeList()) {
                    if (attr.getDataType().getName().compareTo(dataType.getName()) == 0) {
                        attr.setDataType(dataType);


                    } else if (attr.getDataType().getShortCut().compareTo(dataType.getShortCut()) == 0) {
                        attr.setDataType(dataType);


                    }
                }
            }
        }
    }

    void transformAllAttributesToCurrentDataTypes() {
        for (int i = 0; i
                < getComponentCount(); i++) {
            if (getComponent(i) instanceof TableComponent) {
                transformAttributes(((TableComponent) getComponent(i)).getTable());


            }
        }
    }

    void reverseEngineer(ReverseWrapper rw) {
        removeAll();
        referenceTogglePoints.clear();
        references.clear();

        Point location = new Point(50, 50);
        Dimension size = new Dimension(250, 120);


        for (ITable t : rw.getTables()) {
            TableComponent tc = createTableAtPoint(t, location, size);
            tc.sortAttributes();


            if (location.x + 250 > getWidth()) {
                location = new Point(50, location.y + 200);


            } else {
                location = new Point(location.x + 300, location.y);
            }
        }
        for (IReference r : rw.getRefs()) {
            ReferenceData rd = new ReferenceData(r, null);
            references.add(rd);


        }
        observ.notifyObservers(null);
        repaint();


    }

    void unsetForeignKey() {
        if (selectedAttributes.size() > 1) {
            ArrayList<IReference> referencesForThisFK = new ArrayList<IReference>();


            for (ReferenceData refDat : references) {
                if (selectedAttributes.containsAll(refDat.getReference().getAttributeWithFK())) {
                    referencesForThisFK.add(refDat.getReference());


                }
            }
            if (referencesForThisFK.isEmpty()) {
                return;


            } else if (referencesForThisFK.size() == 1) {
                references.remove(getReferenceData(referencesForThisFK.get(0)));
                referenceTogglePoints.remove(getReferenceData(referencesForThisFK.get(0)));


                for (IAttribute attr : referencesForThisFK.get(0).getAttributeWithFK()) {
                    attr.getForeignKey().remove(referencesForThisFK.get(0));


                }
            } else {
                ReferenceChooser rch = new ReferenceChooser(referencesForThisFK);


                if (JOptionPane.showConfirmDialog(this, rch, "Delete reference to:", JOptionPane.OK_CANCEL_OPTION) == 0) {
                    references.remove(getReferenceData(rch.getSelectedRef()));
                    referenceTogglePoints.remove(getReferenceData(rch.getSelectedRef()));


                    for (IAttribute at : rch.getSelectedRef().getAttributeWithFK()) {
                        at.getForeignKey().remove(rch.getSelectedRef());


                    }
                }
            }

        } else {
            IAttribute attr = getActiveTable().getSelectedIAttribute();


            if (attr == null) {
                return;


            }
            if (attr.getForeignKey().isEmpty()) {
                return;


            }
            if (attr.getForeignKey().size() == 1) {
                references.remove(getReferenceData(attr.getForeignKey().get(0)));
                referenceTogglePoints.remove(getReferenceData(attr.getForeignKey().get(0)));


                for (IAttribute at : attr.getForeignKey().get(0).getAttributeWithFK()) {
                    if (at != attr) {
                        at.getForeignKey().remove(attr.getForeignKey().get(0));
                    }


                }
                attr.getForeignKey().clear();


            } else {
                ReferenceChooser rch = new ReferenceChooser(attr.getForeignKey());


                if (JOptionPane.showConfirmDialog(this, rch, "Delete reference to:", JOptionPane.OK_CANCEL_OPTION) == 0) {
                    references.remove(getReferenceData(rch.getSelectedRef()));
                    referenceTogglePoints.remove(getReferenceData(rch.getSelectedRef()));


                    for (IAttribute at : rch.getSelectedRef().getAttributeWithFK()) {
                        if (at != attr) {
                            at.getForeignKey().remove(rch.getSelectedRef());
                        }


                    }
                    attr.getForeignKey().remove(rch.getSelectedRef());


                }
            }
            observ.notifyObservers(attr);


        }
        repaint();

    }

    private class PopUpMenu extends JPopupMenu {

        JMenuItem menuItemAdd;
        JMenuItem menuItemRemove;
        ReferenceData referenceData;
        Point p;

        public PopUpMenu(Point point, ReferenceData refData) {
            this.referenceData = refData;
            this.p = point;
            menuItemAdd = new JMenuItem("Add toggle point");
            menuItemRemove = new JMenuItem("Remove this toggle point");
            add(menuItemAdd);
            add(menuItemRemove);
            menuItemAdd.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    referenceData.getPoints().add(
                            referenceData.getPoints().indexOf(p) + 1,
                            new Point(p.x + 1, p.y + 1));
                    getInstance().repaint();
                }
            });
            menuItemRemove.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    referenceData.getPoints().remove(p);
                    if (referenceData.getPoints().isEmpty()) {
                        referenceData.setAutoRoute(true);
                    }
                    getInstance().repaint();
                }
            });
        }
    }

    private class Observ extends Observable {

        @Override
        public void notifyObservers(Object arg) {
            setChanged();
            super.notifyObservers(arg);
        }
    }
}
