/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package graphics;

import java.awt.Point;
import java.io.Serializable;
import java.util.ArrayList;
import structures.IAttribute;
import structures.IReference;
import structures.ITable;
import structures.Reference;

/**
 *
 * @author mates
 */
public class ReferenceData implements Serializable {
    private IReference reference;
    private ArrayList<Point> points = new ArrayList<Point>();
    boolean autoRoute = true;

    public ReferenceData(ITable tableWithPK, ArrayList<IAttribute> attributesWithPK, ITable referencedTable) {
        reference = new Reference(tableWithPK, attributesWithPK, referencedTable);
    }

    public ReferenceData(IReference reference, ArrayList<Point> points) {
        this.reference = reference;
        if (points == null || points.isEmpty()) {
            autoRoute = true;
        } else {
            this.points.addAll(points);
            autoRoute = false;
        }
    }

    public boolean isAutoRoute() {
        return autoRoute;
    }

    public void setAutoRoute(boolean autoRoute) {
        this.autoRoute = autoRoute;
    }

    public ArrayList<Point> getPoints() {
        return points;
    }

    public IReference getReference() {
        return reference;
    }


}
