/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package structures;

import java.io.Serializable;
import java.util.ArrayList;

/**
 *
 * @author mates
 */
public class Attribute implements IAttribute, Serializable {

    private String name;
    private ISqlDataType dataType;
    private boolean primaryKey;
    private boolean unique;
    private boolean notNull;
    private boolean autoIncrement;
    private ArrayList<IReference> foreignKey;
    private ArrayList<Integer> arguments;

    public Attribute(String name, ISqlDataType dataType) {
        this.name = name;
        this.dataType = dataType;
        arguments = new ArrayList<Integer>();
        foreignKey = new ArrayList<IReference>();
        for (int i = 0;  i< dataType.getArgs().size(); i++) {
            arguments.add(new Integer(32));
        }
    }

    public boolean isAutoIncrement() {
        return autoIncrement;
    }

    public void setAutoIncrement(boolean autoIncrement) {
        if (!dataType.isIncrementable()) {
            autoIncrement = false;
            return;
        }
        this.autoIncrement = autoIncrement;
    }

    public ISqlDataType getDataType() {
        return dataType;
    }

    public void setDataType(ISqlDataType dataType) {
        this.dataType = dataType;
        while (dataType.getArgs().size() < arguments.size()) {
            arguments.remove(arguments.size()-1);
        }
        while (dataType.getArgs().size() > arguments.size()) {
            arguments.add(new Integer(32));
        }
        if (!dataType.isIncrementable())
            autoIncrement = false;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public boolean isNotNull() {
        return notNull;
    }

    public void setNotNull(boolean notNull) {
        this.notNull = notNull;
    }

    public boolean isPrimaryKey() {
        return primaryKey;
    }

    public void setPrimaryKey(boolean primaryKey) {
        this.primaryKey = primaryKey;
        if (primaryKey) {
            unique = false;
            notNull = false;
        }
    }

    public boolean isUnique() {
        return unique;
    }

    public void setUnique(boolean unique) {
        this.unique = unique;
        if (unique) {
            notNull = false;
        }
    }

    public ArrayList<IReference> getForeignKey() {
        return foreignKey;
    }

    public void setForeignKey(ArrayList<IReference> foreignKey) {
        this.foreignKey = foreignKey;
    }

    public ArrayList<Integer> getArguments() {
        return arguments;
    }



}
