/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package structures;

import java.io.Serializable;
import java.util.ArrayList;

/**
 *
 * @author mates
 */
public class Reference implements IReference, Serializable {

    private ITable tableWithFK;
    private ArrayList<IAttribute> attributeWithFK;
    private ITable referencedTable;
    private ArrayList<PairOfAttributes> mapping = new ArrayList<PairOfAttributes>();

    public Reference(ITable tableWithFK, ArrayList<IAttribute> attributeWithFK, ITable referencedTable) {
        this.tableWithFK = tableWithFK;
        this.attributeWithFK = attributeWithFK;
        this.referencedTable = referencedTable;
        for (int i = 0; i < attributeWithFK.size(); i++) {
            attributeWithFK.get(i).getForeignKey().add(this);
            mapping.add(new PairOfAttributes(
                    attributeWithFK.get(i),
                    referencedTable.getPrimaryKey().get(i)));
        }
    }

    public ArrayList<IAttribute> getAttributeWithFK() {
        return attributeWithFK;
    }

    public void setAttributeWithFK(ArrayList<IAttribute> attributeWithPK) {
        this.attributeWithFK = attributeWithPK;
    }

    public ITable getReferencedTable() {
        return referencedTable;
    }

    public void setReferencedTable(ITable referencedTable) {
        this.referencedTable = referencedTable;
    }

    public ITable getTableWithFK() {
        return tableWithFK;
    }

    public void setTableWithFK(ITable tableWithPK) {
        this.tableWithFK = tableWithPK;
    }

    public IAttribute getMappedFk(IAttribute pk) {
        for (PairOfAttributes pair : mapping) {
            if (pair.pkAttribute == pk)
                return pair.fkAttribute;
        }
        return null;
    }

    @Override
    public String toString() {
        return referencedTable.getName();
    }

    public IAttribute getMappedPk(IAttribute fk) {
        for (PairOfAttributes pair : mapping) {
            if (pair.fkAttribute == fk)
                return pair.pkAttribute;
        }
        return null;
    }

    private class PairOfAttributes implements Serializable {
        private IAttribute fkAttribute;
        private IAttribute pkAttribute;

        public PairOfAttributes(IAttribute fkAttribute, IAttribute pkAttribute) {
            this.fkAttribute = fkAttribute;
            this.pkAttribute = pkAttribute;
        }

        public IAttribute getFkAttribute() {
            return fkAttribute;
        }

        public IAttribute getPkAttribute() {
            return pkAttribute;
        }

        public void setFkAttribute(IAttribute fkAttribute) {
            this.fkAttribute = fkAttribute;
        }

        public void setPkAttribute(IAttribute pkAttribute) {
            this.pkAttribute = pkAttribute;
        }
    }

}
